//
//  Controller.h
//  iTunesGamePad
//
//  Created by KOYAMA Yoshiaki on Sun Aug 22 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#include <Carbon/Carbon.h>
#include <IOKit/HID/IOHIDKeys.h>
#include <IOKit/hid/IOHIDUsageTables.h>
#include "HID_Utilities_External.h"

//#define DEBUG_GAMEPAD

enum {
	gButtonAMask =		1,
	gButtonBMask =		1 << 1,
	gButtonCMask =		1 << 2,
	gButtonXMask =		1 << 3,
	gButtonYMask =		1 << 4,
	gButtonZMask =		1 << 5,
	gButtonLMask =		1 << 6,
	gButtonRMask =		1 << 7,
	gButtonStartMask =  1 << 8,
	gButtonYYMask =		1 << 16,
	gButtonXXMask =		1 << 17,
};

struct gamePad {
	SInt32 a;
	SInt32 b;
	SInt32 c;

	SInt32 x;
	SInt32 y;
	SInt32 z;

	SInt32 l;
	SInt32 r;

	SInt32 start;

	SInt32 xx;
	SInt32 yy;	
};

typedef struct gamePad gamePad;

@interface Controller : NSObject {
	IBOutlet id _title_name;
	IBOutlet id _title_artist;
	IBOutlet id _a;
	IBOutlet id _b;
	IBOutlet id _c;
	IBOutlet id _x;
	IBOutlet id _y;
	IBOutlet id _z;
	IBOutlet id _l;
	IBOutlet id _r;
	IBOutlet id _start;
	IBOutlet id _up;
	IBOutlet id _down;
	IBOutlet id _left;
	IBOutlet id _right;

	IBOutlet id _window;

	NSTimer *_observation;
	NSTimer *_nameArtist;
//	gamePad _pad;
}

- (void)openURL:(NSString *)scriptfile;
- (NSString *)getInfo:(NSString *)scriptfile;
- (void)observationTimer:(id)timer;
- (void)pushGamePad:(unsigned long)flag;
- (pRecDevice)getSetCurrentDevice;
- (IBAction)pushButton:(id)sender;
- (void)setNameArtist;

/*
- (void)alertDidEnd:(NSAlert *)alert returnCode:(int)returnCode contextInfo:(void *)contextInfo;
*/

@end
